<?php
namespace app\index\controller;

use daswork\Controller;
use daswork\lib\Config;
use app\index\model\MonthPicker;
use app\index\model\Commission;
use app\index\model\Company;
use app\index\model\Summary;
use app\index\model\Sales;

class Index extends Controller
{
    public $maonth_picker;
    public $commission;
    protected $summary;

    public function __construct()
    {
        parent::__construct();
        $this->maonth_picker = new MonthPicker();
        $this->commission = new Commission();
        $this->summary = new Summary();
    }

    public function index()
    {
        $slect_time = isset($_GET['select_time']) ? $_GET['select_time'] : '';
        if ($slect_time != '') {
            $this->maonth_picker->cur_month = $slect_time;
        }
        $this->assign('maonth_picker', $this->maonth_picker);

        $sql = "select sel.name,su.id as su_id,su.month,su.other_expenses,su.overdraft,su.remark,sel.department from seller sel left join summary su on sel.name = su.name and su.month='".$this->maonth_picker->cur_month."';";
        $data = $this->summary->select($sql);

        // 后勤刘郑总月度
        $total_profit_all = 0;
        $tepi_all = 0;
        $hq_c_rate = 0.05;
        $hq_t_rate = 0.002;
        $total_profit_dp1 = 0;
        $total_profit_dp2 = 0;
        $tepi_dp1 = 0;
        $tepi_dp2 = 0;
        $dp_c_rate = 0.014;
        $dp_t_rate = 0.0014;

        $all_money = 0;

        for ($i=0; $i < count($data); $i++) { 
            $row = &$data[$i];
            $row['id'] = $i+1;
            $name = $row['name'];            
            $row['total_profit'] = $this->commission->totalProfit($name, $this->maonth_picker->cur_month);
            $row['c_rate'] = 0.25;
            $row['c_money'] = ($row['total_profit'] - $row['other_expenses']) * $row['c_rate'];
            $row['tepi'] = $this->commission->tepi($name, $this->maonth_picker->cur_month);
            $row['t_rate'] = 1;
            $row['t_money'] = $row['tepi'] * $row['t_rate'];
            $row['s_money'] = $row['c_money'] + $row['t_money'] + $row['overdraft'];
            $total_profit_all += $row['total_profit'];
            $tepi_all += $row['tepi'];
            // if ($row['name']=='刘莹') {
            //     $ling2['geren'] = $value['s_money'];
            // }
            // if ($value['name']=='郑鑫') {
            //     $ling1['geren'] = $value['s_money'];
            // }
            if ($row['department']=='一部') {
                $total_profit_dp1  += $row['total_profit'];
                $tepi_dp1  += $row['tepi'];
            } else {
                $total_profit_dp2  += $row['total_profit'];
                $tepi_dp2  += $row['tepi'];
            }
            $all_money += $row['s_money'];
        }

        // 后勤
        $data[$i+1]['id'] = $i+1;
        $data[$i+1]['name'] = '后勤人员';
        $data[$i+1]['su_id'] = '';
        $data[$i+1]['month'] = $this->maonth_picker->cur_month;
        $data[$i+1]['other_expenses'] = 0;
        $data[$i+1]['overdraft'] = 0;
        $data[$i+1]['remark'] = '';
        $data[$i+1]['department'] = '';
        $data[$i+1]['total_profit'] = $total_profit_all;
        $data[$i+1]['c_rate'] = $hq_c_rate;
        $data[$i+1]['c_money'] = $total_profit_all * $hq_c_rate;
        $data[$i+1]['tepi'] = $tepi_all;
        $data[$i+1]['t_rate'] = $hq_t_rate;
        $data[$i+1]['t_money'] = $tepi_all * $hq_t_rate;
        $data[$i+1]['s_money'] = $data[$i+1]['c_money'] + $data[$i+1]['t_money'];

        $all_money += $data[$i+1]['s_money'];

        // 郑总月度提成
        $data[$i+2]['id'] = $i+2;
        $data[$i+2]['name'] = '郑总月度';
        $data[$i+2]['su_id'] = '';
        $data[$i+2]['month'] = $this->maonth_picker->cur_month;
        $data[$i+2]['other_expenses'] = 0;
        $data[$i+2]['overdraft'] = 0;
        $data[$i+2]['remark'] = '';
        $data[$i+2]['department'] = '';
        $data[$i+2]['total_profit'] = $total_profit_dp1;
        $data[$i+2]['c_rate'] = $dp_c_rate;
        $data[$i+2]['c_money'] = $total_profit_dp1 * $dp_c_rate;
        $data[$i+2]['tepi'] = $tepi_dp1;
        $data[$i+2]['t_rate'] = $dp_t_rate;
        $data[$i+2]['t_money'] = $tepi_dp1 * $dp_t_rate;
        $data[$i+2]['s_money'] = $data[$i+2]['c_money'] + $data[$i+2]['t_money'];

        $all_money += $data[$i+2]['s_money'];

        // 刘总月度提成
        $data[$i+3]['id'] = $i+3;
        $data[$i+3]['name'] = '刘总月度';
        $data[$i+3]['su_id'] = '';
        $data[$i+3]['month'] = $this->maonth_picker->cur_month;
        $data[$i+3]['other_expenses'] = 0;
        $data[$i+3]['overdraft'] = 0;
        $data[$i+3]['remark'] = '';
        $data[$i+3]['department'] = '';
        $data[$i+3]['total_profit'] = $total_profit_dp2;
        $data[$i+3]['c_rate'] = $dp_c_rate;
        $data[$i+3]['c_money'] = $total_profit_dp2 * $dp_c_rate;
        $data[$i+3]['tepi'] = $tepi_dp2;
        $data[$i+3]['t_rate'] = $dp_t_rate;
        $data[$i+3]['t_money'] = $tepi_dp2 *$dp_t_rate;
        $data[$i+3]['s_money'] = $row['c_money'] + $row['t_money'];
        
        $all_money += $data[$i+3]['s_money'];

        // 合计
        $total = [];
        $total['other_expenses'] = 0;
        $total['total_profit'] = $total_profit_all;
        $total['c_rate'] = 0.25;
        $total['c_money'] = ($total_profit_all - $total['other_expenses']) * 0.25;
        $total['tepi'] = $tepi_all;
        $total['t_rate'] = 1.00;
        $total['t_money'] = $tepi_all * 1.00;
        $total['s_money'] = $all_money;
        // var_dump($data);
        // exit;
        $this->assign('data', $data);
        $this->assign('total', $total);
        $this->fetch();
    }

    public function salesData()
    {
        $sales = new Sales();
        echo json_encode(['code' => 0, 'data'=>$sales->salesData]);
    }
}
