<?php
namespace app\index\controller;

use daswork\Controller;
use daswork\lib\Config;
use app\index\model\MonthPicker;
use app\index\model\Commission;
use app\index\model\Seller as SellerModel;

class Seller extends Controller
{
    private $model;

    public function __construct()
    {
        parent::__construct();
        $this->model = new SellerModel();
    }

    public function index()
    {
        $name = isset($_GET['seller_name']) ? $_GET['seller_name'] : '';
        $data = $this->model->listByName($name);
        $this->assign("data", $data);
        $this->assign("seller_name", $name);
        $this->fetch();
    }

    public function save()
    {
        $params = escapeString($_POST);
        $id = $params['id'];
        $name = $params['name'];
        $department = $params['department'];
        $data = [
            'id' => $id,
            'name' => $name,
            'department' => $department
        ];

        if ($id) {
            $res = $this->model->updateById($data);
        } else {
            unset($data['id']);
            $res = $this->model->save($data);
            // $id = $mydb->lastInsertRowID();
        }
        if ($res===false) {
            echo json_encode(['code' => 1, "msg"=>$this->model->lastErrorMsg()]);
        } else {
            echo json_encode(['code' => 0, "msg"=>"操作成功"]);
        }
    }

    public function delete()
    {
        $params = escapeString($_POST);
        $id = $params['id'];
        $res = $this->model->deleteById($id);
        if ($res===false) {
            echo json_encode(['code' => 1, "msg"=>$this->model->lastErrorMsg()]);
        } else {
            echo json_encode(['code' => 0, "msg"=>"操作成功"]);
        }
    }
}